//+------------------------------------------------------------------+
//|                                         better_mt_statements.mq4 |
//|                                      Copyright 2018, nicholishen |
//|                                          http://forexfactory.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, nicholishen"
#property link "http://forexfactory.com/nicholishen"
#property version "v0.02 (BETA)"
#property icon "images/icon.ico"
#property description "Better statements for your trade history."
#property description ""
#property description "Please enable DLLs so I can open your newly created statement in a browser window."
#property strict
#property script_show_inputs
#include <stdlib.mqh>

#define __HTML__ "<!DOCTYPE html><html lang='en'><head><meta charset='UTF-8'><meta name='viewport' content='width=device-width, initial-scale=1.0'><meta http-equiv='X-UA-Compatible' content='ie=edge'><link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css' integrity='sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm' crossorigin='anonymous'><link href='https://fonts.googleapis.com/css?family=Fira+Sans+Extra+Condensed|Inconsolata' rel='stylesheet'> <script src='https://cdn.plot.ly/plotly-latest.min.js'></script> <style>table{font-family:'Inconsolata',monospace}.infonav{background-color:lightcoral;font-family:'Fira Sans Extra Condensed',sans-serif;font-size: .7em}.version{text-align:right}.heading-cont{height:100%;font-size:0.8em;overflow:auto}.table-row{padding-bottom:0px;padding-top:15px;font-size: .8em}.broker{text-align:left;font-family:'Fira Sans Extra Condensed',sans-serif}.closed{margin-top:12px}.odd{background-color:lightgray}.statement-header{margin-top:2%;margin-bottom:2%;text-align:left}.main-table{font-size:1.2em}</style><title>Statement</title></head><body><div class='alert alert-primary alert-dismissible fade show' role='alert'> <strong>Thank you for trying out the Better MT Statements Beta!</strong> Please be sure to leave some feedback on the <a href='https://www.forexfactory.com/showthread.php?p=10949615'>discussion thread</a>. <button type='button' class='close' data-dismiss='alert' aria-label='Close'> <span aria-hidden='true'>&times;</span> </button></div><div class='container-fluid'><div class='container main-bg'><div class='container statement-header'><h1 class='display-4'>{BROKER}</h1><p class='lead'>{STATEMENT_DATE_RANGE}</p><hr class='my-4'><div class='row heading-cont'><div class='col-4'><ul><li>{ACCOUNT_NUMBER}</li><li>{ACCOUNT_NAME}</li></ul></div><div class='col-4'><ul><li>{ACCOUNT_CURRENCY}</li><li>1:{ACCOUNT_LEVERAGE}</li></ul></div><div class='col-4'><ul><li>{FILTERED_BY_SYMBOLS}</li><li>{FILTERED_BY_MAGICS}</li></ul></div></div></div></div><div class='row table-row'><div class='table-responsive'><table class='table table-striped table-bordered table-hover main-table'><thead class='thead-dark'><tr><th scope='col'>Floating P/L</th><th scope='col'>Closed P/L</th><th scope='col'>Total Size</th><th scope='col'>Total Comm.</th><th scope='col'>Total Swap</th><th scope='col'>Balance</th><th scope='col'>Equity</th><th scope='col'>Free Margin</th></tr></thead><tbody><tr><td>{TOTAL_FLOATING_PL}</td><td>{TOTAL_CLOSED_PL}</td><td>{TOTAL_SIZE}</td><td>{TOTAL_COMM}</td><td>{TOTAL_SWAP}</td><td>{BALANCE}</td><td>{EQUITY}</td><td>{FREE_MARGIN}</td></tr></tbody></table></div></div><div class='row'><div class='col-12'><div id=plot_balance></div><div id=plot_trades></div></div></div><div class='row table-row'><div class='table-responsive'><table class='table table-bordered table-hover table-sm'><caption>Open Trades</caption><thead class='thead-dark'><tr><th scope='col'>Ticket</th><th scope='col'>Open Time</th><th scope='col'>Type</th><th scope='col'>Size</th><th scope='col'>Symbol</th><th scope='col'>Price</th><th scope='col'>SL</th><th scope='col'>TP</th><th scope='col'>Close Time</th><th scope='col'>Price</th><th scope='col'>Comm.</th><th scope='col'>Swap</th><th scope='col'>Profit</th><th scope='col'>Comment</th></tr></thead><tbody> {INSERT_OPEN_TRADES}<tr class='table-secondary'><td></td><td></td><td></td><td> <b>{OPEN_TOTAL_SIZE}</b></td><td></td><td></td><td></td><td></td><td></td><td></td><td> <B>{OPEN_TOTAL_COMM}</B></td><td> <b>{OPEN_TOTAL_SWAP}</b></td><td> <b>{OPEN_TOTAL_PROFIT}</b></td><td> <b>{OPEN_TOTAL_NETPROFIT}</b></td></tr></tbody></table></div></div><div class='row table-row'><div class='table-responsive'><table class='table table-bordered table-hover table-sm'><caption>Closed Trades</caption><thead class='thead-dark'><tr><th scope='col'>Ticket</th><th scope='col'>Open Time</th><th scope='col'>Type</th><th scope='col'>Size</th><th scope='col'>Symbol</th><th scope='col'>Price</th><th scope='col'>SL</th><th scope='col'>TP</th><th scope='col'>Close Time</th><th scope='col'>Price</th><th scope='col'>Comm.</th><th scope='col'>Swap</th><th scope='col'>Profit</th><th scope='col'>Comment</th></tr></thead><tbody> {INSERT_CLOSED_TRADES}<tr class='table-secondary'><td></td><td></td><td></td><td> <b>{CLOSED_TOTAL_SIZE}</b></td><td></td><td></td><td></td><td></td><td></td><td></td><td> <b>{CLOSED_TOTAL_COMM}</b></td><td> <b>{CLOSED_TOTAL_SWAP}</b></td><td> <b>{CLOSED_TOTAL_PROFIT}</b></td><td> <b>{CLOSED_TOTAL_NETPROFIT}</b></td></tr></tbody></table></div></div></div> <script>(function(){var d3=Plotly.d3;var d4=Plotly.d3;var WIDTH_IN_PERCENT_OF_PARENT=100,HEIGHT_IN_PERCENT_OF_PARENT=100;var gd3=d3.select('#plot_trades').style({width:WIDTH_IN_PERCENT_OF_PARENT+'%','margin-left':(100-WIDTH_IN_PERCENT_OF_PARENT)/2+'%',height:'400px','margin-top':'0px'});var gd4=d4.select('#plot_balance').style({width:WIDTH_IN_PERCENT_OF_PARENT+'%','margin-left':(100-WIDTH_IN_PERCENT_OF_PARENT)/2+'%',height:'400px','margin-top':'0px'});var gd=gd3.node();var gd2=gd4.node();console.log('Script begin -->');var closed_trades=document.getElementsByClassName('orders_closed');var closed_list=[];var closed_count=[];var open_trades=document.getElementsByClassName('orders_open');var open_list=[];var open_count=[];for(t of closed_trades){closed_list.push(parseInt(t.innerText));closed_count.push(closed_list.length);} for(t of open_trades){open_list.push(parseInt(t.innerText));open_count.push(open_list.length);} var closed_reversed=closed_list.reverse();var open_reversed=open_list.reverse();var balance_list=[];var balance_count=[];var begin_balance={BEGIN_BALANCE};for(t of closed_reversed){if(balance_list.length<=0) balance_list.push(t+begin_balance);else balance_list.push(t+balance_list[balance_list.length-1]);balance_count.push(balance_list.length);} console.log(closed_trades);console.log(closed_list);console.log(closed_list.length);console.log(open_trades);console.log(open_list);console.log(open_list.length);var trace1={x:closed_count,y:closed_reversed,type:'scatter',name:'closed',line:{color:'rgb(158, 38, 214)',width:2}};var trace2={x:open_count,y:open_reversed,type:'scatter',name:'open'};var trace3={x:balance_count,y:balance_list,type:'scatter',name:'balance',line:{width:3}};var data=[trace1,trace2];var data2=[trace3];var config={displayModeBar:false,staticPlot:true,};Plotly.newPlot(gd,data,{showlegend:true},{displayModeBar:false});Plotly.newPlot(gd2,data2,{showlegend:true},{displayModeBar:false});window.onresize=function(){Plotly.Plots.resize(gd);Plotly.Plots.resize(gd2);};})();</script> <script src='https://code.jquery.com/jquery-3.2.1.slim.min.js' integrity='sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN' crossorigin='anonymous'></script> <script src='https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js' integrity='sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q' crossorigin='anonymous'></script> <script src='https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js' integrity='sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl' crossorigin='anonymous'></script> </body></html>"

#import "shell32.dll"
int ShellExecuteW(int hWnd, string Verb, string File, string Parameter, string Path, int ShowCmd);
#import
datetime expiration = D'2018.08.01';
input datetime InpStartDate = D'2018.01.01';//Report start date
input datetime InpEndDate = D'2018.06.01';//Report end date
input int InpMagic = 0;//Filter by magic number
input string InpSymbol = "";//Filter by currency or pair
int DebugMax = 30000;
string _name = "statement.html";
//+------------------------------------------------------------------+
#include "StringEnhanced.mqh"

void OnStart()
{
   //---
   //if(!IsDllsAllowed())
   //{
   //   Alert("Enable DLL imports and reload the script.");
   //   return;
   //}
   // if (TimeCurrent() > expiration)
   // {
   //    Alert("BETA has expired.");
   //    return;
   // }
   string broker = AccountInfoString(ACCOUNT_COMPANY);
   string date_range = StringFormat("%s - %s", TimeToString(InpStartDate, TIME_DATE), TimeToString(InpEndDate, TIME_DATE));
   string account_number = (string)AccountInfoInteger(ACCOUNT_LOGIN);
   string account_name = AccountInfoString(ACCOUNT_NAME);
   string account_currency = AccountInfoString(ACCOUNT_CURRENCY);
   string leverage = (string)AccountInfoInteger(ACCOUNT_LEVERAGE);
   string filter_magic = InpMagic == 0 ? "No Magic Specified" : "Magic[" + string(InpMagic) + "]";
   string filter_symbol = InpSymbol == "" ? "All Symbols" : InpSymbol;
   string balance = DoubleToString(AccountInfoDouble(ACCOUNT_BALANCE), 2);
   string equity = DoubleToString(AccountInfoDouble(ACCOUNT_EQUITY), 2);
   string free_margin = DoubleToString(AccountInfoDouble(ACCOUNT_MARGIN_FREE), 2);

   String html = __HTML__;
   html.Print();
   html.Replace("{BROKER}", broker);
   html.Replace("{STATEMENT_DATE_RANGE}", date_range);
   html.Replace("{ACCOUNT_NUMBER}", account_number);
   html.Replace("{ACCOUNT_NAME}", account_name);
   html.Replace("{ACCOUNT_CURRENCY}", account_currency);
   html.Replace("{ACCOUNT_LEVERAGE}", leverage);
   html.Replace("{FILTERED_BY_MAGICS}", filter_magic);
   html.Replace("{FILTERED_BY_SYMBOLS}", filter_symbol);
   html.Replace("{BALANCE}", balance);
   html.Replace("{EQUITY}", equity);
   html.Replace("{FREE_MARGIN}", free_margin);

   string context_up = "success";
   string context_dn = "danger";

   String temp = "<tr class='table-{CONTEXT_CLASS}'>";
   temp += "<td class='tTicket'>{TICKET}</td>";
   temp += "<td class='tOpenTime'>{OPENTIME}</td>";
   temp += "<td class='tType'>{TYPE}</td>";
   temp += "<td class='tSize'>{SIZE}</td>";
   temp += "<td class='tSymbol'>{SYMBOL}</td>";
   temp += "<td class='tOpenPrice'>{OPENPRICE}</td>";
   temp += "<td class='tSL'>{SL}</td>";
   temp += "<td class='tTP'>{TP}</td>";
   temp += "<td class='tCloseTime'>{CLOSETIME}</td>";
   temp += "<td class='tClosePrice'>{CLOSEPRICE}</td>";
   temp += "<td class='tComm'>{COMM}</td>";
   //temp+="<td>{TAXES}</td>";
   temp += "<td class='tSwap'>{SWAP}</td>";
   temp += "<td class='tProfit {TRADE_TAG}'>{PROFIT}</td>";
   temp += "<td class='tComment'>{COMMENT}</td>";
   temp += "</tr>";

   String orders_to_html = "";
   struct Totes
   {
      double commission, swap, profit, size;
   };
   Totes closed = {0};
   int cnt = 0;
   for (int i = OrdersHistoryTotal() - 1; i >= 0; i--)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && (OrderType() < 2) && (OrderMagicNumber() == InpMagic || InpMagic == 0) && (InpSymbol == "" || StringFind(OrderSymbol(), InpSymbol) >= 0))
      //&&(OrderCloseTime() >= InpStartDate && OrderCloseTime() <= InpEndDate))
      {
         closed.commission += OrderCommission();
         closed.profit += OrderProfit();
         closed.swap += OrderSwap();
         closed.size += OrderLots();
         int digits = (int)SymbolInfoInteger(OrderSymbol(), SYMBOL_DIGITS);
         String me = temp;
         me.Replace("{CONTEXT_CLASS}", OrderProfit() >= 0.0 ? context_up : context_dn);
         me.Replace("{TICKET}", string(OrderTicket()));
         me.Replace("{OPENTIME}", TimeToString(OrderOpenTime()));
         me.Replace("{TYPE}", OrderType() == OP_BUY ? "BUY" : "SELL");
         me.Replace("{SIZE}", DoubleToString(OrderLots(), 2));
         me.Replace("{SYMBOL}", OrderSymbol());
         me.Replace("{OPENPRICE}", DoubleToString(OrderOpenPrice(), digits));
         me.Replace("{SL}", DoubleToString(OrderStopLoss(), digits));
         me.Replace("{TP}", DoubleToString(OrderTakeProfit(), digits));
         me.Replace("{CLOSETIME}", TimeToString(OrderCloseTime()));
         me.Replace("{CLOSEPRICE}", DoubleToString(OrderClosePrice(), digits));
         me.Replace("{COMM}", DoubleToString(OrderCommission(), 2));
         //me.Replace("{TAXES}","0.00");
         me.Replace("{SWAP}", DoubleToString(OrderSwap(), 2));
         me.Replace("{PROFIT}", DoubleToString(OrderProfit(), 2));
         me.Replace("{TRADE_TAG}", "orders_closed");
         string comm = "Magic = [";
         if (OrderComment() == "")
            comm += string(OrderMagicNumber()) + "]";
         else
            comm = OrderComment();
         me.Replace("{COMMENT}", comm);
         orders_to_html += me;
         cnt++;
         if (cnt >= DebugMax)
            break;
      }
   }
   html.Replace("{INSERT_CLOSED_TRADES}", orders_to_html.Str());
   html.Replace("{CLOSED_TOTAL_SIZE}", DoubleToString(closed.size, 2));
   html.Replace("{CLOSED_TOTAL_COMM}", DoubleToString(closed.commission, 2));
   //html.Replace("{CLOSED_TOTAL_TAXES}","0.00");
   html.Replace("{CLOSED_TOTAL_SWAP}", DoubleToString(closed.swap, 2));
   html.Replace("{CLOSED_TOTAL_PROFIT}", DoubleToString(closed.profit, 2));
   html.Replace("{CLOSED_TOTAL_NETPROFIT}", DoubleToString(closed.profit + closed.swap + closed.commission, 2));
   html.Replace("{TOTAL_CLOSED_PL}", DoubleToString(closed.profit + closed.swap + closed.commission, 2));

   Totes open = {0};
   orders_to_html = "";
   cnt = 0;
   for (int i = OrdersTotal() - 1; i >= 0; i--)
   {
      if (OrderSelect(i, SELECT_BY_POS) && (OrderType() < 2) && (OrderMagicNumber() == InpMagic || InpMagic == 0) && (InpSymbol == "" || StringFind(OrderSymbol(), InpSymbol) >= 0))
      //&&(OrderCloseTime() >= InpStartDate && OrderCloseTime() <= InpEndDate))
      {
         open.commission += OrderCommission();
         open.profit += OrderProfit();
         open.swap += OrderSwap();
         open.size += OrderLots();
         int digits = (int)SymbolInfoInteger(OrderSymbol(), SYMBOL_DIGITS);
         String me = temp;
         me.Replace("{CONTEXT_CLASS}", OrderProfit() >= 0.0 ? context_up : context_dn);
         me.Replace("{TICKET}", string(OrderTicket()));
         me.Replace("{OPENTIME}", TimeToString(OrderOpenTime()));
         me.Replace("{TYPE}", OrderType() == OP_BUY ? "BUY" : "SELL");
         me.Replace("{SIZE}", DoubleToString(OrderLots(), 2));
         me.Replace("{SYMBOL}", OrderSymbol());
         me.Replace("{OPENPRICE}", DoubleToString(OrderOpenPrice(), digits));
         me.Replace("{SL}", DoubleToString(OrderStopLoss(), digits));
         me.Replace("{TP}", DoubleToString(OrderTakeProfit(), digits));
         me.Replace("{CLOSETIME}", TimeToString(OrderCloseTime()));
         me.Replace("{CLOSEPRICE}", DoubleToString(OrderClosePrice(), digits));
         me.Replace("{COMM}", DoubleToString(OrderCommission(), 2));
         //me.Replace("{TAXES}","0.00");
         me.Replace("{SWAP}", DoubleToString(OrderSwap(), 2));
         me.Replace("{PROFIT}", DoubleToString(OrderProfit(), 2));
         me.Replace("{TRADE_TAG}", "orders_open");
         string comm = "Magic = [";
         if (OrderComment() == "")
            comm += string(OrderMagicNumber()) + "]";
         else
            comm = OrderComment();
         me.Replace("{COMMENT}", comm);
         orders_to_html += me;
         cnt++;
         if (cnt >= DebugMax)
            break;
      }
   }
   html.Replace("{INSERT_OPEN_TRADES}", orders_to_html.Str());
   html.Replace("{OPEN_TOTAL_SIZE}", DoubleToString(open.size, 2));
   html.Replace("{OPEN_TOTAL_COMM}", DoubleToString(open.commission, 2));
   //html.Replace("{CLOSED_TOTAL_TAXES}","0.00");
   html.Replace("{OPEN_TOTAL_SWAP}", DoubleToString(open.swap, 2));
   double net_profit = closed.profit + closed.swap + closed.commission + open.profit + open.swap + open.commission;
   html.Replace("{OPEN_TOTAL_PROFIT}", DoubleToString(net_profit, 2));

   html.Replace("{OPEN_TOTAL_NETPROFIT}", DoubleToString(open.profit + open.swap + open.commission, 2));

   html.Replace("{TOTAL_FLOATING_PL}", DoubleToString(open.profit, 2));
   html.Replace("{TOTAL_SIZE}", DoubleToString(open.size + closed.size, 2));
   html.Replace("{TOTAL_COMM}", DoubleToString(open.commission + closed.commission, 2));
   html.Replace("{TOTAL_SWAP}", DoubleToString(open.swap + closed.swap, 2));

   html.Replace("{BEGIN_BALANCE}", DoubleToString(AccountBalance() - net_profit, 2));

   string file = _name;
   int h = FileOpen("HTML/" + file, FILE_WRITE | FILE_TXT);
   if (h == INVALID_HANDLE)
      Print("INVALID HANDLE ", ErrorDescription(_LastError));
   ResetLastError();
   FileWriteString(h, html.Str());
   Print(ErrorDescription(_LastError));
   FileClose(h);
   file = TerminalInfoString(TERMINAL_DATA_PATH) + "\\MQL4\\Files\\HTML\\" + file;
   if (!IsDllsAllowed())
   {
      MessageBox("DLL imports aren't enabled. Please enable DLL imports or manually enter the file into a browser.\r\n\r\n" + file, "ERROR: Please enable DLL imports.");
      return;
   }
   int r = ShellExecuteW(NULL, "open", file, NULL, NULL, 1);
}
//+------------------------------------------------------------------+
